import ipywidgets as widgets

def true_false_test(ax, f, X, df, step=None, value=None):
    '''
    Plot tangent lines to the graph of the function for each point of the given interval.
    
    ax
      The diagram.
    f
      The function.
    df
      Its derivation.
    X
      The interval.
    '''

    if step is None:
        step = (X[-1] - X[0]) / (len(X) - 1) 
    
    if value is None:
        value = (X[0] + X[-1]) / 2 # počiatočná hodnota

    def t(X, a): # dotyčnica grafu funkcie f v bode [a,f(a)]
        return df(a) * (X - a) + f(a)
    
    zorder = len(ax.lines)

    def plot_tangent(a): # graf dotyčnice
        if len(ax.lines) > zorder: # uprav hodnoty
            ax.lines[zorder].set_ydata(t(X, a))
            ax.lines[zorder+1].set_data(a, f(a))
        else: # počiatočná hodnota
            ax.plot(X, t(X, value))
            ax.plot(a, f(value), 'o', c=ax.lines[zorder].get_color())

    a = widgets.FloatSlider(min=X[0], max=X[-1], step=step, value=value)
    ui = widgets.HBox([widgets.Label(r"x-ová súradnica bodu dotyku dotyčnice a grafu funkcie"), a])
    widgets.interactive_output(plot_tangent, {'a': a})
    display(ui)